unit DCallyDemo2a;
{
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
interface
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, WinGL, AppEvnts, ExtCtrls, PCX, jpeg, ZIPFiles;

type
  TForm1 = class(TForm)
    WinGL1: TWinGL;
    ApplicationEvents1: TApplicationEvents;
    ZIPFile1: TZIPFile;
    LogoImage: TZIPTexture;
    FPSImage: TZIPTexture;
    CursorImage: TZIPTexture;
    LodImage: TZIPTexture;
    MenuImage: TZIPTexture;
    procedure ApplicationEvents1Idle(Sender: TObject; var Done: Boolean);
    procedure WinGL1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure WinGL1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure WinGL1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure WinGL1Resize(Sender: TObject);
    procedure WinGL1Paint(Sender: TObject);
    procedure WinGL1Keypress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure WinGL1CreateGL(Sender: TObject);
    procedure FPSImagePaint(Sender: TObject);
    procedure MenuImagePaint(Sender: TObject);
    procedure LodImagePaint(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
 Demo,Model,Menu,DelphiGL;

function GrayPalette:HPalette;
 var
  log:TMaxLogPalette;
  col:integer;
 begin
  log.palVersion:=$300;
  log.palNumEntries:=256;
  for col:=0 to 255 do with log.palPalEntry[col] do begin
   peRed:=col;
   peGreen:=col;
   peBlue:=col;
   peFlags:=pc_nocollapse;
  end;
  result:=CreatePalette(PLogPalette(@log)^);
 end;

procedure rgb2bgr(var p);
 var
  i:array[0..2] of byte absolute p;
  t:byte;
 begin
  t:=i[2]; i[2]:=i[0]; i[0]:=t;
 end;

procedure RAW2BMP(filename:string);
 var
  b:TBitmap;
  a:TBitmap;
  f:file;
  w,h,d:integer;
  x,y:integer;
  pa:pchar;
  pb:^integer;
 begin
  filemode:=0;
  assignfile(f,'data\'+filename+'.raw');
  reset(f,1);
  blockread(f,w,sizeof(w));
  blockread(f,h,sizeof(h));
  blockread(f,d,sizeof(d));
  b:=TBitmap.Create;
  b.width:=w;
  b.height:=h;
  if d=3 then begin // 24bit
   b.PixelFormat:=pf24bit;
   for y:=0 to h-1 do BlockRead(f,b.ScanLine[y]^,w*3);
   b.saveToFile(filename+'24.bmp');
  end else begin // 32bit
   a:=TBitmap.Create;
   a.width:=w;
   a.height:=h;
   a.PixelFormat:=pf8bit;
   a.Palette:=GrayPalette;
   b.PixelFormat:=pf32bit;
   for y:=0 to h-1 do begin
    pb:=b.ScanLine[y];
    BlockRead(f,pb^,w*4);
    pa:=a.ScanLine[y];
    for x:=0 to w-1 do begin
     pa[x]:=chr(pb^ shr 24);
     rgb2bgr(pb^);
     inc(pb);
    end;
   end;
   b.saveToFile(filename+'32.bmp');
   a.savetofile(filename+'_a.bmp');
   a.free;
  end;
  closefile(f);
  b.PixelFormat:=pf8bit;
  b.saveToFile(filename+'8.bmp');
  b.Free;
 end;

procedure LoadRAW(filename:string; b:TBitmap);
 var
  f:file;
  w,h,d:integer;
  x,y:integer;
  pi:^integer;
 begin
  filemode:=0;
  assignfile(f,'data\'+filename+'.raw');
  reset(f,1);
  blockread(f,w,sizeof(w));
  blockread(f,h,sizeof(h));
  blockread(f,d,sizeof(d));
  b.width :=w;
  b.height:=h;
  if d=3 then begin // 24bit
   b.PixelFormat:=pf24bit;
   for y:=h-1 downto 0 do BlockRead(f,b.ScanLine[y]^,3*w);
   b.PixelFormat:=pf32Bit;
  end else begin // 32bit
   b.PixelFormat:=pf32bit;
   for y:=h-1 downto 0 do BlockRead(f,b.ScanLine[y]^,4*w);
   pi:=b.ScanLine[h-1];
   for y:=0 to h-1 do begin
    for x:=0 to w-1 do begin
     rgb2bgr(pi^);
     inc(pi);
    end;
   end;
  end;
  b.savetofile('test.bmp');
  closefile(f);
 end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 TheDemo:=TDemo.Create;
(*
 raw2bmp('menu');
 raw2bmp('logo');
 raw2bmp('cursor');
 raw2bmp('fps');
 raw2bmp('lod');
*)

end;

procedure TForm1.WinGL1CreateGL(Sender: TObject);
begin
  if(theDemo.onInit=false) then begin
    writeln('Initialization of the demo failed.');
    halt;
  end;
//  ShowMessage(glGetString(GL_EXTENSIONS));
end;

procedure TForm1.ApplicationEvents1Idle(Sender: TObject;
  var Done: Boolean);
begin
  Done:=False;
  TheDemo.OnIdle;
  if CursorImage.AlphaBlending>0 then CursorImage.AlphaBlending:=CursorImage.AlphaBlending-0.05;
  WinGL1.Paint;
end;

procedure TForm1.WinGL1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  // redirect the message to the demo instance
  theDemo.onMouseButtonDown(2*ord(button), x, theDemo.Height - y - 1);
end;

procedure TForm1.WinGL1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    theDemo.onMouseButtonUp(2*ord(button), x, theDemo.Height - y - 1);
end;

procedure TForm1.WinGL1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  theDemo.onMouseMove(x, theDemo.Height - y - 1);
  CursorImage.Left:=x+1;
  CursorImage.Top :=y;
  CursorImage.AlphaBlending:=1;
  MenuImage.AlphaBlending:=(2*x-MenuImage.Left)/MenuImage.Left;
  LODImage.AlphaBlending:=(2*y-LODImage.Top)/LODImage.Top;
end;

procedure TForm1.WinGL1Resize(Sender: TObject);
begin
  theDemo.setDimension(WinGL1.width, WinGL1.height);
end;

procedure TForm1.WinGL1Paint(Sender: TObject);
begin
  theDemo.onRender;
end;

procedure TForm1.WinGL1Keypress(Sender: TObject; var Key: Char);
begin
  theDemo.onKey(key, 0,0);
end;

procedure TForm1.FPSImagePaint(Sender: TObject);
var
  digit:integer;
  digitId:integer;
  x:integer;
  tx:single;
  r:TRect;
begin
  FPSImage.Setup; // select Texture
  digit:=TheDemo.fps;
  r:=Rect(0,0,16,16);
  for digitID:=2 downto 0 do begin
   r.Left :=16*(digit mod 10);
   r.Right:=r.Left+16;
   digit  :=digit div 10;
   FPSImage.DrawRect(16*digitId,0,r);
  end;
end;

procedure TForm1.MenuImagePaint(Sender: TObject);
const
 MENUITEM_MOTION_X:array[0..2] of integer = ( 42, 80, 118 );
 MENUITEM_MOTION_Y:array[0..2] of integer = ( 168, 102, 168 );
var
 y,h:integer;
 motionBlend:array[0..2] of single;
 motionX, motionY:integer;
begin
// draw the unselected options
 MenuImage.Setup;
 MenuImage.Draw(128,0);

// override with selected options
 case theDemo.Model.State of
  STATE_IDLE  : begin y:= 0; h:=28 end;
  STATE_FANCY : begin y:=28; h:=28 end;
//STATE_MOTION
  else          begin y:=56; h:=106 end;
 end;
 MenuImage.DrawRect(0,y,Rect(0,y,128,y+h));

 if TheMenu.fx1TimeSpan>0 then MenuImage.DrawRect(0,162,Rect(0,162,128,162+28));
 if TheMenu.fx2TimeSpan>0 then MenuImage.DrawRect(0,190,Rect(0,190,128,190+28));

 if TheMenu.Skeleton  then MenuImage.DrawRect( 0,218,Rect( 0,218,32,218+37));
 if TheMenu.WireFrame then MenuImage.DrawRect(32,218,Rect(32,218,64,218+37));
 if TheMenu.Lighting  then MenuImage.DrawRect(64,218,Rect(64,218,96,218+37));

 if TheMenu.NextTimeSpan>0 then MenuImage.DrawRect(96,218,Rect(96,218,128,218+38));

 if h=106 {state = STATE_MOTION} then begin
  // get current blending factors
  theDemo.Model.getMotionBlend(motionBlend);
  // calculate the current motion point
  motionX := round(motionBlend[0] * MENUITEM_MOTION_X[0] + motionBlend[1] * MENUITEM_MOTION_X[1] + motionBlend[2] * MENUITEM_MOTION_X[2]);
  motionY := round(motionBlend[0] * MENUITEM_MOTION_Y[0] + motionBlend[1] * MENUITEM_MOTION_Y[1] + motionBlend[2] * MENUITEM_MOTION_Y[2]);
  y:=WinGL1.Height-(MenuImage.Top+MenuImage.Height);
  glLineWidth(2.0);
  glDisable(GL_TEXTURE_2D);
  glBegin(GL_LINES);
   glColor4f(1.0, 1.0, 0.0,MenuImage.AlphaBlending);
   glVertex2i(MenuImage.Left + MENUITEM_MOTION_X[0], y + MENUITEM_MOTION_Y[0]);
   glVertex2i(MenuImage.Left + motionX, y + motionY);

   glColor4f(0.0, 1.0, 1.0,MenuImage.AlphaBlending);
   glVertex2i(MenuImage.Left + MENUITEM_MOTION_X[1], y + MENUITEM_MOTION_Y[1]);
   glVertex2i(MenuImage.Left + motionX, y + motionY);

   glColor4f(1.0, 0.0, 1.0,MenuImage.AlphaBlending);
   glVertex2i(MenuImage.Left + MENUITEM_MOTION_X[2], y + MENUITEM_MOTION_Y[2]);
   glVertex2i(MenuImage.Left + motionX, y + motionY);
  glEnd();
  glLineWidth(1.0);
 end;

end;

procedure TForm1.LodImagePaint(Sender: TObject);
var
 lod:integer;
begin
{ 0  47<-------200------>247 256
  +---+-------------------+--+-- 0
  |LOD ====================  |
  +--------------------------+--32
  |LOD --------------------  |
  +--------------------------+--64
}
// draw two parts of the LOD bitmap
 lod:=247-round(200*theDemo.Model.LodLevel);
 LodImage.Setup;
 LodImage.DrawRect(  0,0,Rect(  0,32,lod,64));
 LodImage.DrawRect(lod,0,Rect(lod, 0,256,32));
end;

end.
